<template>
  <v-card>
    <v-card-title v-if="!titre">
      <v-container>
        <v-row>
          <v-col>{{ date }}</v-col>
          <v-col>
            <boutons-actions-presence :present-ce-jours-la="presentCeJoursLa" :ajouter-presence="ajouterPresence"
                                      :retirer-presence="retirerPresence"/>
          </v-col>
        </v-row>
      </v-container>

    </v-card-title>
    <v-tooltip v-if="titre">
      <template v-slot:activator="{ on, attrs }">
        <v-card-title v-bind="attrs"
                      v-on="on">
          <div class="pr-2">{{ titre }}</div>
          <v-spacer></v-spacer>
          <boutons-actions-presence :present-ce-jours-la="presentCeJoursLa" :ajouter-presence="ajouterPresence"
                                    :retirer-presence="retirerPresence"/>
        </v-card-title>
      </template>
      {{ date }}
    </v-tooltip>
    <v-card-text>
      <v-list>
        <v-list-item v-for="item in listeDePresences" v-bind:key="item.id_google">
          <user-label :user="item.utilisateur"></user-label>
          <v-icon v-if="item.type_presence === 'Office'">mdi-domain</v-icon>
          <v-icon v-else-if="item.type_presence === 'Home'">mdi-home</v-icon>
          <v-icon v-else>mdi-map-marker</v-icon>
        </v-list-item>
      </v-list>
    </v-card-text>
  </v-card>
</template>

<script>
import moment from 'moment'
import presenceService from "@/services/presences-service"
import UserLabel from "@/components/UserLabel";
import {mapGetters} from "vuex";
import BoutonsActionsPresence from "@/components/BoutonsActionsPresence";
import googleCalendarService from "@/services/google-calendar-service";

export default {
  name: "PresenceDuJour",
  components: {BoutonsActionsPresence, UserLabel},
  props: {
    date: {type: String, default: moment().format('YYYY-MM-DD')},
    titre: String
  },
  data() {
    return {
      listeDePresences: []
    }
  },
  computed: {
    ...mapGetters(['currentUser']),
    presentCeJoursLa() {
      return this.listeDePresences.filter(nomPresent => nomPresent.utilisateur.fullname === this.currentUser.fullname).length !== 0
    }
  },
  mounted() {
    presenceService.getPresencesForDate(this.date).then(presences => {
      this.listeDePresences = presences
    })
  },
  methods: {
    ajouterPresence: function (type_presence) {
      this.listeDePresences.push({
        type_presence: type_presence,
        utilisateur: this.currentUser
      })
      presenceService.getSynchronizedCalendars(this.currentUser.id_google).then(calendars => {
        calendars.forEach(calendar => {
          googleCalendarService.envoyerEvenement(this.$gapi.getGapiClient(), calendar.id_calendrier, {
            start: {date: this.date},
            end: {date: moment(this.date).add(1, "day").format("YYYY-MM-DD")},
            summary: "auto-présence :" + type_presence
          })
        })
      })
      presenceService.addPresence({
        date: this.date,
        id_google: this.currentUser.id_google,
        type_presence: type_presence
      })
    },
    retirerPresence: function () {
      const user = this.$gapi.getUserData()
      this.listeDePresences = this.listeDePresences.filter(presence => presence.utilisateur.id_google !== user.id)
      presenceService.removePresence({
        date: this.date,
        id_google: user.id
      })
      presenceService.getSynchronizedCalendars(this.currentUser.id_google).then(calendars => {
        calendars.forEach(calendar => {
          googleCalendarService.listerEvenements(this.$gapi.getGapiClient(), calendar.id_calendrier, this.date).then(events => {
            console.log(events)
            events.forEach(event => {
              googleCalendarService.supprimerEvenement(this.$gapi.getGapiClient(), calendar.id_calendrier, event.id)
            })
          })
        })
      })
    }
  }
}
</script>

